unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics, pngimage,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, atDiagram, DiagramUtils, dgrclasses, Vcl.ExtCtrls, AdvPicture,
  Vcl.ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    atDiagram1: TatDiagram;
    Button2: TButton;
    Panel2: TPanel;
    Image1: TImage;
    Splitter1: TSplitter;
    Label1: TLabel;
    CheckBoxLine: TCheckBox;
    CheckBoxPic: TCheckBox;
    ButtonSave: TButton;
    CheckBox1: TCheckBox;
    procedure ButtonSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure atDiagram1DrawShape(Sender: TObject; ABlock: TCustomDiagramBlock; AInfo: TDiagramDrawInfo;
      ABlockInfo: TDiagramDrawBlockInfo; var APainted: Boolean);
    procedure CheckBoxLineClick(Sender: TObject);
    procedure CheckBoxPicClick(Sender: TObject);
    procedure Load;
    procedure CheckBox1Click(Sender: TObject);
    procedure atDiagram1MouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
      var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    picblk,lineblk : TDiagramBlock;
    grp : TGroupBlock;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  atDiagram1.GraphicLib := dglGdiPlus;
  Load;
end;

procedure TForm1.atDiagram1DrawShape(Sender: TObject; ABlock: TCustomDiagramBlock; AInfo: TDiagramDrawInfo;
  ABlockInfo: TDiagramDrawBlockInfo; var APainted: Boolean);
begin
  if ABlock.Name = 'lineblk' then
    begin
    ABlock.Drawer.Canvas := AInfo.Canvas;
    AInfo.Canvas.pen.Color := clred;
    AInfo.Canvas.pen.Width := 2;
    ABlock.Drawer.AutoMoveTo(0,50);
    ABlock.Drawer.AutoRotLineTo(50,100);
    ABlock.Drawer.AutoRotLineTo(100,50);
    ABlock.Drawer.AutoRotLineTo(50,0);
    ABlock.Drawer.AutoRotLineTo(0,50);
    end;
end;

procedure TForm1.Load;
begin
  picblk := TDiagramBlock.Create(Self);
  picblk.Diagram := atDiagram1;
  picblk.Left := 100;
  picblk.Top := 100;
  picblk.Width := 200;
  picblk.Height := 200;
  picblk.Transparent := true;
  picblk.Picture.LoadFromFile('pic2.png'); // bmp');
  picblk.Shape := bsNoShape;


  lineblk := TDiagramBlock.Create(Self);
  lineblk.Diagram := atDiagram1;
  lineblk.Left := 100;
  lineblk.Top := 100;
  lineblk.Width := 200;
  lineblk.Height := 200;
  lineblk.Transparent := true;
  lineblk.Shape := bsNoShape;
  lineblk.Name := 'lineblk';

  grp := TGroupBlock.Create(self);
  grp.Diagram := atDiagram1;
  grp.Members.Add(picblk);
  grp.Members.Add(lineblk);
end;

procedure TForm1.atDiagram1MouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
begin
  label1.Caption := 'ZoomRatio '+ floattostr(atDiagram1.ZoomRatio);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  panel2.Width := round(grp.Width * atDiagram1.zoomratio) + 2;
  panel2.Height := round(grp.Height * atDiagram1.ZoomRatio) + 2;
  image1.Canvas.Brush.Color := clMoneyGreen;
  image1.Canvas.Fillrect(rect(0,0,image1.Width,image1.Height));

  image1.Picture.Bitmap.Width := picblk.Picture.Width;
  image1.Picture.Bitmap.Height := picblk.Picture.Height;

  if picblk.Visible then
    image1.Picture.bitmap.Canvas.draw(0,0,picblk.Picture.Graphic);
  if lineblk.Visible then
    lineblk.DrawBlockInCanvas(image1.Canvas,rect(0,0,image1.Width,image1.Height));

end;


procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if Checkbox1.Checked then
    picblk.Shape := bsRectangle
  else
    picblk.Shape := bsNoShape;
end;

procedure TForm1.CheckBoxLineClick(Sender: TObject);
begin
  lineblk.Visible := checkboxLine.checked;
end;

procedure TForm1.CheckBoxPicClick(Sender: TObject);
begin
  picblk.Visible := checkboxPic.checked;

end;

procedure TForm1.ButtonSaveClick(Sender: TObject);
var
  bmp : TBitmap;
  i : integer;
  r : TRect;
begin
  bmp := TBitmap.Create;
  bmp.PixelFormat := pf32bit;

  BMP.Width := picblk.Picture.Graphic.Width;
  BMP.Height := picblk.Picture.Graphic.Height;
  bmp.canvas.Brush.Color := clMoneyGreen;
  bmp.Canvas.Fillrect(rect(0,0,bmp.Width,bmp.Height));

  if picblk.Visible then
    //atDiagram1.PaintToBitmap(bmp,esNetto);
    bmp.Canvas.draw(0,0,picblk.Picture.Graphic);
  if lineblk.Visible then
    begin
    r.Left := 0;
    r.top := 0;
    r.Right := round(lineblk.Width / atDiagram1.ZoomRatio);
    r.Bottom := round(lineblk.Height / atDiagram1.ZoomRatio);
    lineblk.DrawBlockInCanvas(bmp.Canvas,r); //rect(0,0,bmp.Width,bmp.Height));
    end;
  i := 0;
  while fileexists(format('img%d.bmp',[i])) do
    inc(i);
  bmp.SaveToFile(format('img%d.bmp',[i]));
  bmp.Free;
end;

end.
